Subject: [bug#64188] [PATCH 0/8] More package tuning

From: Efraim Flashner <[email-masked]>
Date: Mon, 26 Jun 2023 11:34:27 +0300

On Sun, Jun 25, 2023 at 10:52:14PM +0200, Ludovic Courtès wrote:
> Efraim Flashner <[email-masked]> skribis:
> 
> > * guix/transformations.scm (tuned-package)[build-system]: Don't replace
> > the build-system if inheriting from the go-build-system.
> > [arguments]: If using the go-build-system add a phase to set the
> > micro-architecture for Go.
> 
> [...]
> 
> > @@ -570,14 +571,42 @@ (define (tuned-package p micro-architecture)
> >    (package
> >      (inherit p)
> >      (build-system
> > -      (build-system-with-tuning-compiler (package-build-system p)
> > -                                         micro-architecture))
> > +      ;; The go compiler doesn't need to be wrapped.
> > +      ;; XXX: This is where we check for supported micro-architectures.
> > +      (if (eq? (build-system-name (package-build-system p))
> > +               'go)
> > +        (package-build-system p)
> > +        (build-system-with-tuning-compiler (package-build-system p)
> > +                                           micro-architecture)))
> >      (arguments
> >       ;; The machine building this package may or may not be able to run code
> >       ;; for MICRO-ARCHITECTURE.  Because of that, skip tests; they are run for
> >       ;; the "baseline" variant anyway.
> >       (substitute-keyword-arguments (package-arguments p)
> > -       ((#:tests? _ #f) #f)))
> > +       ((#:tests? _ #f) #f)
> > +       ;; We add the tuning parameter after the default GO flags are set.
> > +       ((#:phases phases '%standard-phases)
> > +        (if (eq? (build-system-name (package-build-system p))
> > +                 'go)
> > +          #~(modify-phases #$phases
> > +              (add-after 'setup-go-environment 'set-microarchitecture
> 
> Can we use the same approach as before with
> ‘build-system-with-tuning-compiler’?  That seems more robust to me and
> it’d be more consistent.

I'll look to see how to move this into
build-system-with-tuning-compiler. I think I previously got hung-up on
the tuning-compiler function which wouldn't work for go. At first glance
it looks like I could just lift-and-shift the extra phase over. I'll
just have to make sure that either it's only for the go-build-system or
occurs sometime after the setup-go-environment phase but before/after a
phase which exists in all build systems. Then it's the toss-up between
leaving it as-is and only occurring with the go-build-system or also
occurring on any tuned package which also has go code.

-- 
Efraim Flashner   <[email-masked]>   רנשלפ םירפא
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted